image: jakzal/phpqa:php8.0

before_script:
    - composer install
    - composer update
    - php -v
    - php -m

#cache:
#    paths:
#        - vendor/

stages:
    - SecurityChecker
    - CodingStandards
    - UnitTests

security-checker:
    stage: SecurityChecker
    script:
        - local-php-security-checker  --path=./composer.lock
    allow_failure: false

phpcs:
    stage: CodingStandards
    script:
        - phpcs -v --standard=PSR12 --ignore=./src/Kernel.php ./src
    allow_failure: false

phpstan:
    stage: CodingStandards
    script:
        - phpstan analyse ./src
    allow_failure: false

twig-lint:
    stage: CodingStandards
    script:
        - twig-lint lint ./templates
    allow_failure: false

phpunit:
    image: php:8.0-apache
    stage: UnitTests
    services:
        - name: mysql:8.0
          alias: mysql
    variables:
        MYSQL_ROOT_PASSWORD: pass_test
        MYSQL_DATABASE: myapptest_test
        MYSQL_USER: myapptest
        MYSQL_PASSWORD: myapptest
        DATABASE_URL: 'mysql://myapptest:myapptest@mysql:3306/myapptest'
    before_script:
        - apt-get update && apt-get install -y git libzip-dev
        - curl -sSk https://getcomposer.org/installer | php -- --disable-tls && mv composer.phar /usr/local/bin/composer
        - docker-php-ext-install mysqli pdo pdo_mysql zip
        - composer install
        - composer update
        - php bin/console doctrine:database:drop --if-exists --force --env=test
        - php bin/console doctrine:database:create --env=test
        - php bin/console doctrine:migration:migrate --env=test --no-interaction
        - php -v
        - php -m
    script:
        - php bin/phpunit --testdox
    allow_failure: false

